//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
   
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Magenta
#property indicator_width1     1
#property indicator_color2     Aqua
#property indicator_width2     2
#property indicator_color3     White
#property indicator_style3     STYLE_DASH
#property indicator_color4     Crimson
#property indicator_width4     1
#property indicator_color5     LimeGreen
#property indicator_width5     1
#property indicator_level1     0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    Per              = 14;
extern int    T3Period         = 5;
extern int    T3Price          = PRICE_CLOSE;
extern double T3Hot            = 0.7;
extern bool   T3Original       = false;
extern int    HighLowPeriod    = 30;
extern bool   ShowChannel      = true;
extern bool   ShowZigZag       = true;
extern bool   Interpolate      = true;

extern string _                = "alerts settings";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

extern string  __              = "arrows settings";
extern bool   ShowArrows       = true;
extern string arrowsIdentifier = "implus channel arrows";
extern color  arrowsUpColor    = Lime;
extern color  arrowsDnColor    = Orange;


//
//
//
//
//

double buf[];
double sig[];
double HighBuffer[];
double LowBuffer[];
double ZigZagBuffer[];
double ZigZagLow[];
double ZigZagHigh[];
double trend[];

//
//
//
//
//

double point = 0;
double pipMultiplier = 1;
int    digit; 

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
  
int init() 
{
   digit = Digits;
   
   if(digit == 3 || digit == 5)
   { 
      point = Point * 10; 
      pipMultiplier = 10; 
   }
   else
   {
      point = Point;
      pipMultiplier = 1;
   }
   
   IndicatorBuffers(8);
      SetIndexBuffer(0,buf);
      SetIndexBuffer(1,sig);
      SetIndexBuffer(2,ZigZagBuffer);
      SetIndexBuffer(3,HighBuffer);
      SetIndexBuffer(4,LowBuffer);
      SetIndexBuffer(5,ZigZagLow);
      SetIndexBuffer(6,ZigZagHigh);
      SetIndexBuffer(7,trend);
      SetIndexStyle(2,DRAW_SECTION);
      SetIndexEmptyValue(0,0);
      SetIndexEmptyValue(1,0);
      SetIndexEmptyValue(2,0);
      SetIndexEmptyValue(5,0);
      SetIndexEmptyValue(6,0);
      SetIndexLabel(2,NULL);
      
          Per = MathMax(Per,1);
   
      //
      //
      //
      //
      //
      
         if (ShowChannel)
           {
           SetIndexStyle(3,DRAW_LINE);
           SetIndexStyle(4,DRAW_LINE);
           }
         else      
           {
           SetIndexStyle(3,DRAW_NONE);
           SetIndexStyle(4,DRAW_NONE);
           }
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"  DayImplus ("+Per+","+T3Period+","+DoubleToStr(T3Hot,2)+")");
      
   return(0);
}

//
//
//
//
//

int deinit(){  if (!calculateValue && ShowArrows) deleteArrows();  return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,k,n,limit;
   
   int lastZag;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { buf[0] = MathMin(limit+1,Bars-1); return(0); }
           
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
   
   //
   //
   //
   //
   //
         
   if (ShowZigZag)
   for (lastZag=limit+1; lastZag<Bars; lastZag++) if (ZigZagLow[lastZag] != 0 || ZigZagHigh[lastZag] != 0) break;

   //
   //
   //
   //
   //
      
   for(i=limit; i>=0; i--)
   {
          double imp = 0;
          for (j=0; j<Per; j++)
          {  
          imp = imp + (Open[i+j] - Close[i+j]);  
          }
             
          imp = MathRound(imp/point);

             if(imp != 0) 
                imp  = -imp;
      
                    buf[i]  = iT3(imp,T3Period,T3Hot,T3Original,i);
                    sig[i]  = buf[i+2]; 
              LowBuffer[i]  = buf[ArrayMinimum(buf,HighLowPeriod,i)];
              HighBuffer[i] = buf[ArrayMaximum(buf,HighLowPeriod,i)];
                   trend[i] = trend[i+1];
                   
      if (buf[i] > LowBuffer[i]  && buf[i+1] == LowBuffer[i+1])  trend[i] =  1;  
      if (buf[i] < HighBuffer[i] && buf[i+1] == HighBuffer[i+1]) trend[i] = -1; 
      
      manageArrow(i); 
      
      //
      //
      //
      //
      //
      
      if (!ShowZigZag) continue;
      
      ZigZagLow[i]  = 0;
         ZigZagHigh[i] = 0;
         if (LowBuffer[i] < LowBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == LowBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  LowBuffer[i];
                   ZigZagLow[i]          =  LowBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (HighBuffer[i] > HighBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == HighBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  HighBuffer[i];
                   ZigZagHigh[i]         =  HighBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (ZigZagBuffer[i] != 0)
            {
               ZigZagBuffer[i] = 0;
               for (lastZag=i+1; lastZag<Bars; lastZag++)
               {
                  if (ZigZagLow[lastZag]  != 0) { ZigZagBuffer[lastZag] = ZigZagLow[lastZag];  break; }
                  if (ZigZagHigh[lastZag] != 0) { ZigZagBuffer[lastZag] = ZigZagHigh[lastZag]; break; }
               }
              } 
            } 
             
     manageAlerts();      
     return(0); 
     }
  
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    
    if (ShowZigZag)
    for (lastZag=limit+1; lastZag<Bars; lastZag++) if (ZigZagLow[lastZag] != 0 || ZigZagHigh[lastZag] != 0) break;
    
    for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
            buf[i]          = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Period,T3Price,T3Hot,T3Original,HighLowPeriod,ShowChannel,ShowZigZag,0,y);
            sig[i]          = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Period,T3Price,T3Hot,T3Original,HighLowPeriod,ShowChannel,ShowZigZag,1,y);
            ZigZagBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Period,T3Price,T3Hot,T3Original,HighLowPeriod,ShowChannel,ShowZigZag,2,y);
            HighBuffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Period,T3Price,T3Hot,T3Original,HighLowPeriod,ShowChannel,ShowZigZag,3,y);
            LowBuffer[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Period,T3Price,T3Hot,T3Original,HighLowPeriod,ShowChannel,ShowZigZag,4,y);
            ZigZagLow[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Period,T3Price,T3Hot,T3Original,HighLowPeriod,ShowChannel,ShowZigZag,5,y);
            ZigZagHigh[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Period,T3Price,T3Hot,T3Original,HighLowPeriod,ShowChannel,ShowZigZag,6,y);
            trend[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Period,T3Price,T3Hot,T3Original,HighLowPeriod,ShowChannel,ShowZigZag,7,y);
  
            manageArrow(i); 
            
            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; k < n; k++)
               {
                  buf[i+k]       = buf[i]       + (buf[i+n]       - buf[i])       * k/n;
                  sig[i+k]       = sig[i]       + (sig[i+n]       - sig[i])       * k/n;
                  HighBuffer[i+k]= HighBuffer[i]+ (HighBuffer[i+n]- HighBuffer[i])* k/n;
                  LowBuffer[i+k] = LowBuffer[i] + (LowBuffer[i+n] - LowBuffer[i]) * k/n;

            //
            //
            //
            //
            //
               
            }  	            
   }
      
   manageAlerts();
      
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" DayImplus channel ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," DayImplus channel "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
      
//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//
//
//
//
//

void manageArrow(int i)
{
   if (!calculateValue && ShowArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,228,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,230,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
  
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//
//

